from org.bukkit.entity import Player
from org.bukkit.block import BlockFace

class SchilderPlugin(PythonPlugin):
    schilderListe = None
    spielerListe = None

    def onEnable(self):
        global schilderListe
        global spielerListe
        schilderListe = []
        spielerListe = []
        pass

    def onCommand(self, sender, command, label, args):
        global schilderListe
        global spielerListe

        if isinstance(sender, Player):
            spieler = sender

            if len(args) < 1:
                spieler.sendMessage("Bitte Schild-Befehl angeben!")
            elif args[0] == "bauen":
                welt = spieler.getWorld()

                #Schild platziert
                finalBlock = spieler.getLocation()
                blockListe = spieler.getLineOfSight(None, 30)
                
                for block in blockListe:
                    if block.getType() == bukkit.Material.AIR:
                        finalBlock = block
                    else:
                        break

                finalBlock.setType(bukkit.Material.OAK_SIGN)

                #Rotation
                rotationen = [BlockFace.SOUTH, BlockFace.SOUTH_SOUTH_WEST, BlockFace.SOUTH_WEST, BlockFace.WEST_SOUTH_WEST, BlockFace.WEST, BlockFace.WEST_NORTH_WEST, BlockFace.NORTH_WEST, BlockFace.NORTH_NORTH_WEST, BlockFace.NORTH, BlockFace.NORTH_NORTH_EAST, BlockFace.NORTH_EAST, BlockFace.EAST_NORTH_EAST, BlockFace.EAST, BlockFace.EAST_SOUTH_EAST, BlockFace.SOUTH_EAST, BlockFace.SOUTH_SOUTH_EAST]

                rotation = spieler.getLocation().getYaw()
                rotation = (rotation + 180) % 360 #entgegengesetzte Richtung
                rotation = rotation / 22 #umwandeln fuer Schild
                
                schild = finalBlock.getState()
                schildDaten = schild.getData()
                schildDaten.setFacingDirection(rotationen[int(rotation)])
                schild.setData(schildDaten)
                schild.update()

                #Schild zu Liste hinzufuegen
                schilderListe.append(schild)
                spielerListe.append(spieler.getUniqueId())
                spieler.sendMessage("Das neu gebaute Schuld hat die ID " + str(schilderListe.index(schild)))
            elif args[0] == "text":
                if len(args) < 4:
                    spieler.sendMessage("Bitte Schild-ID, Zeile und Text angeben!")
                else:
                    #parameter lesen
                    schildId = int(args[1])
                    zeile = int(args[2])
                    text = args[3]
                    for i in range(4, len(args)):
                        text = text + " " + args[i]

                    #ID pruefen
                    if (schildId < 0) | (schildId >= len(schilderListe)):
                        spieler.sendMessage("Falsche Schild-ID!")
                    #spieler pruefen
                    elif spielerListe[schildId] != spieler.getUniqueId():
                        spieler.sendMessage("Dieses Schild gehoert einem anderen Spieler!")
                    #Text zuweisen
                    else:
                        schilderListe[schildId].setLine(zeile, text)
                        schilderListe[schildId].update()
            else:
                spieler.sendMessage("Unbekannter Schild-Befehl!")
        else:
            self.getLogger().info("Dieser Befehl kann nur von Spielern ausgefuehrt werden!")

        return True
